## ros-noetic-robotraconteur 0.16.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3)
project(RobotRaconteur)

include(cmake/CMakeMacros.cmake)
include(CTest)

include(CheckTypeSize)
check_type_size("long int" SIZEOF_LONG_INT BUILTIN_TYPES_ONLY)

configure_file("${CMAKE_SOURCE_DIR}/RobotRaconteurCore/include/RobotRaconteur/RobotRaconteurConfig.h"
               "${CMAKE_BINARY_DIR}/RobotRaconteurConfig.h" COPYONLY)

file(STRINGS "${CMAKE_SOURCE_DIR}/RobotRaconteurCore/include/RobotRaconteur/RobotRaconteurConfig.h"
     ROBOTRACONTEUR_CONFIG_VERSION REGEX "#define +ROBOTRACONTEUR_VERSION_TEXT +\"[0-9]+\\.[0-9]+\\.[0-9]+\"")
if("${ROBOTRACONTEUR_CONFIG_VERSION}" STREQUAL "")
    message(FATAL_ERROR "Could not read Robot Raconteur version.")
endif()
string(REGEX REPLACE "#define ROBOTRACONTEUR_VERSION_TEXT \"([0-9]+\\.[0-9]+\\.[0-9]+)\"" "\\1" ROBOTRACONTEUR_VERSION
                     ${ROBOTRACONTEUR_CONFIG_VERSION})
message(STATUS "Robot Raconteur version: ${ROBOTRACONTEUR_VERSION}")

if(NOT ROBOTRACONTEUR_VERSION_SEMVER)
    set(ROBOTRACONTEUR_VERSION_SEMVER ${ROBOTRACONTEUR_VERSION})
endif()

string(REGEX REPLACE "^([0-9]+\\.[0-9]+\\.[0-9]+)" "\\1" ROBOTRACONTEUR_VERSION_S ${ROBOTRACONTEUR_VERSION_SEMVER})
if(NOT ${ROBOTRACONTEUR_VERSION} VERSION_EQUAL ${ROBOTRACONTEUR_VERSION_S})
    message(
        FATAL_ERROR
            "Supplied semver ${ROBOTRACONTEUR_VERSION_SEMVER} does not equal config version ${ROBOTRACONTEUR_VERSION}")
endif()

configure_file(${CMAKE_SOURCE_DIR}/cmake/rrversion.txt.in ${CMAKE_BINARY_DIR}/rrversion.txt @ONLY)

include(GNUInstallDirs)

find_package(Doxygen)
option(BUILD_DOCUMENTATION "Build documentation using Doxygen" ${DOXYGEN_FOUND})

if(APPLE)
    set(CMAKE_CXX_STANDARD 11)
endif()

set(BUILD_CORE ON CACHE BOOL "Build core library")
if(BUILD_CORE)
    add_subdirectory(RobotRaconteurCore)
    set(RobotRaconteur_CORE_LIBRARY RobotRaconteurCore)
else()
    find_package(RobotRaconteur REQUIRED)
    set(RobotRaconteur_CORE_LIBRARY RobotRaconteurCore)
endif()

set(ROBOTRACONTEUR_ROS ON CACHE BOOL "Build Robot Raconteur for ROS workspace")
if(ROBOTRACONTEUR_ROS)
    set(BUILD_GEN true CACHE BOOL "Build RobotRaconteurGen")
    set(BUILD_TESTING true CACHE BOOL "Build RobotRaconteurTest")
    if($ENV{ROS_PYTHON_VERSION} LESS 3)
        set(BUILD_PYTHON true CACHE BOOL "Build Python wrappers")
    else()
        set(BUILD_PYTHON3 true CACHE BOOL "Build Python 3 wrappers")
    endif()
endif()

# if(EXISTS ${CMAKE_SOURCE_DIR}/generated_src)
#     set(USE_PREGENERATED_SOURCE ON CACHE BOOL ON)
# else()
#     set(USE_PREGENERATED_SOURCE OFF CACHE BOOL OFF)
# endif()

# Use pregenerated source with ROS package
set(USE_PREGENERATED_SOURCE ON CACHE BOOL ON)
set(PREGENERATED_SOURCE_DIR ${CMAKE_SOURCE_DIR}/generated_src CACHE PATH "generated_src directory location")

set(BUILD_GEN ON CACHE BOOL "Build RobotRaconteurGen")
if(BUILD_GEN)
    add_subdirectory(RobotRaconteurGen)
endif()

set(BUILD_PYTHON "" CACHE BOOL "Build Python wrappers")
if(BUILD_PYTHON)
    add_subdirectory(RobotRaconteurPython)
endif()

set(BUILD_PYTHON3 "" CACHE BOOL "Build Python 3.x wrappers")
if(BUILD_PYTHON3)
    add_subdirectory(RobotRaconteurPython3)
endif()

set(BUILD_NET "" CACHE BOOL "Build .NET wrappers")
if(BUILD_NET)
    add_subdirectory(RobotRaconteurNET)
endif()

set(BUILD_JAVA "" CACHE BOOL "Build Java wrappers")
if(BUILD_JAVA)
    add_subdirectory(RobotRaconteurJava)
endif()

set(BUILD_MATLAB_MEX OFF CACHE BOOL OFF)
if(BUILD_MATLAB_MEX)
    add_subdirectory(RobotRaconteurMex)
endif()

if(BUILD_TESTING)
    add_subdirectory(test)
endif()

# if(BUILD_PYTHON OR BUILD_NET OR BUILD_JAVA)
#     if(USE_PREGENERATED_SOURCE)
#         set(PREGENERATED_SOURCE_DIR ${CMAKE_SOURCE_DIR}/generated_src CACHE PATH "generated_src directory location")
#         if(NOT EXISTS ${PREGENERATED_SOURCE_DIR}/Python/swigwordsize32/RobotRaconteurPythonPYTHON_wrap.cxx
#            OR NOT EXISTS ${PREGENERATED_SOURCE_DIR}/Python3/swigwordsize32/RobotRaconteurPythonPYTHON_wrap.cxx
#            OR NOT EXISTS
#               ${PREGENERATED_SOURCE_DIR}/Java/swigwordsize32/com/robotraconteur/RobotRaconteurJavaJAVA_wrap.cxx
#            OR NOT EXISTS ${PREGENERATED_SOURCE_DIR}/NET/swigwordsize32/RobotRaconteurNETCSHARP_wrap.cxx)
#             message(FATAL_ERROR "Invalid PREGENERATED_SOURCE_DIR")
#         endif()
#     else()
#         include(${CMAKE_SOURCE_DIR}/cmake/package_source_swig.cmake)
#     endif()
# endif()

include(CMakePackageConfigHelpers)
configure_package_config_file(
    "cmake/Config.cmake.in" "${CMAKE_BINARY_DIR}/${CMAKE_PROJECT_NAME}Config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${CMAKE_PROJECT_NAME}"
    PATH_VARS CMAKE_INSTALL_LIBDIR CMAKE_INSTALL_INCLUDEDIR CMAKE_INSTALL_BINDIR)
write_basic_package_version_file("${CMAKE_BINARY_DIR}/${CMAKE_PROJECT_NAME}ConfigVersion.cmake"
                                 VERSION ${ROBOTRACONTEUR_VERSION} COMPATIBILITY AnyNewerVersion)

install(FILES ${CMAKE_BINARY_DIR}/${CMAKE_PROJECT_NAME}Config.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${CMAKE_PROJECT_NAME})
install(FILES ${CMAKE_BINARY_DIR}/${CMAKE_PROJECT_NAME}ConfigVersion.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${CMAKE_PROJECT_NAME})

list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.git/")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.vs/")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.vscode/")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.github/")
# list(APPEND CPACK_SOURCE_IGNORE_FILES "/build/")
list(APPEND CPACK_SOURCE_IGNORE_FILES "^${CMAKE_SOURCE_DIR}/build[\\\\-_/]")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.cache")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.gitignore")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.travis.yml")
list(APPEND CPACK_SOURCE_IGNORE_FILES "/\.clang-format")

set(CPACK_PACKAGE_VERSION ${ROBOTRACONTEUR_VERSION_SEMVER})

set(CPACK_SOURCE_INSTALLED_DIRECTORIES "${CMAKE_SOURCE_DIR};/;${CMAKE_BINARY_DIR}/generated_src;/generated_src")
set(CPACK_SOURCE_TBZ2 OFF CACHE BOOL "" FORCE)
set(CPACK_SOURCE_TXZ OFF CACHE BOOL "" FORCE)
set(CPACK_SOURCE_TZ OFF CACHE BOOL "" FORCE)
if(NOT WIN32)
    set(CPACK_SOURCE_TGZ ON CACHE BOOL "" FORCE)
endif()
set(CPACK_SOURCE_ZIP ON CACHE BOOL "" FORCE)

include(CPack)

if(ROBOTRACONTEUR_ROS OR ROBOTRACONTEUR_COLCON)
    # Allows Colcon to find non-Ament packages when using workspace underlays
    file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/share/ament_index/resource_index/packages/robotraconteur "")
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/ament_index/resource_index/packages/robotraconteur
            DESTINATION share/ament_index/resource_index/packages)
    file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/share/robotraconteur/hook/ament_prefix_path.dsv
         "prepend-non-duplicate;AMENT_PREFIX_PATH;")
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/robotraconteur/hook/ament_prefix_path.dsv
            DESTINATION share/robotraconteur/hook)
endif()

file(STRINGS "${CMAKE_SOURCE_DIR}/package.xml" ROBOTRACONTEUR_ROS_PKG_VERSION_1
     REGEX "<version>[0-9]+\\.[0-9]+\\.[0-9]+</version>")
string(REGEX REPLACE "<version>([0-9]+\\.[0-9]+\\.[0-9]+)</version>" "\\1" ROBOTRACONTEUR_ROS_PKG_VERSION
                     ${ROBOTRACONTEUR_ROS_PKG_VERSION_1})
if(NOT "${ROBOTRACONTEUR_ROS_PKG_VERSION}" VERSION_EQUAL "{ROBOTRACONTEUR_VERSION}")
    message(
        FATAL_ERROR "Found ROS package version ${ROBOTRACONTEUR_ROS_PKG_VERSION} mismatch ${ROBOTRACONTEUR_VERSION}")
endif()

=== RobotRaconteurCore/CMakeLists.txt ===
set(BUILD_SHARED_LIBS FALSE CACHE BOOL "Build using shared Robot Raconteur core library")

set(RobotRaconteur_DISABLE_MESSAGE4 FALSE CACHE BOOL "Disable Robot Raconteur message version 3 by default")
set(RobotRaconteur_DISABLE_STRINGTABLE FALSE CACHE BOOL "Disable Robot Raconteur string table by default")
mark_as_advanced(RobotRaconteur_DISABLE_MESSAGE4 RobotRaconteur_DISABLE_STRINGTABLE)

include(FindBoost)
set(Boost_USE_MULTITHREADED ON)
set(Boost_USE_STATIC_RUNTIME OFF CACHE BOOL "")
find_package(
    Boost
    COMPONENTS date_time
               filesystem
               system
               regex
               chrono
               atomic
               thread
               random
               program_options
    REQUIRED)

if(WIN32 AND ROBOTRACONTEUR_USE_OPENSSL)
    find_package(OpenSSL REQUIRED)
endif()

if(ANDROID)
    # TODO: Determine how to handle this list(REMOVE_ITEM Boost_LIBRARIES ${BOOST_THREAD_LIBRARY})
    find_package(OpenSSL REQUIRED)
endif()

if("${CMAKE_SYSTEM}" MATCHES "Linux" AND NOT ANDROID)
    find_path(DBUS_INCLUDE_DIR dbus.h NAMES dbus/dbus.h PATH_SUFFIXES dbus-1.0)
    find_library(DBUS_LIBRARY dbus-1)
    get_filename_component(DBUS_LIBRARY_DIR ${DBUS_LIBRARY} DIRECTORY)
    find_path(DBUS_INCLUDE_ARCH_DIR dbus/dbus-arch-deps.h HINTS ${DBUS_LIBRARY_DIR}/dbus-1.0/include)
    find_path(LIBUSB_INCLUDE_DIR libusb.h PATH_SUFFIXES libusb-1.0)
    find_package(OpenSSL REQUIRED)
endif()

if(APPLE)
    find_library(COREFOUNDATION_FRAMEWORK "CoreFoundation")
    if(NOT COREFOUNDATION_FRAMEWORK)
        message(FATAL_ERROR "CoreFoundation framework not found")
    endif()

    find_library(SECURITY_FRAMEWORK "Security")
    if(NOT SECURITY_FRAMEWORK)
        message(FATAL_ERROR "Security framework not found")
    endif()

    find_library(CORESERVICES_FRAMEWORK "CoreServices")
    if(NOT CORESERVICES_FRAMEWORK)
        message(FATAL_ERROR "CoreFoundation framework not found")
    endif()

    find_package(OpenSSL REQUIRED)
endif()

if(UNIX AND NOT "${CMAKE_SYSTEM}" MATCHES "Linux")
    # TODO: Determine how to handle this list(REMOVE_ITEM Boost_LIBRARIES ${BOOST_THREAD_LIBRARY})
    find_package(OpenSSL REQUIRED)
endif()

set(RobotRaconteurCore_src
    src/AutoResetEvent.cpp
    src/CallbackMember.cpp
    src/DataTypes.cpp
    src/Endpoint.cpp
    src/Error.cpp
    src/IOUtils.cpp
    src/ThreadPool.cpp
    src/MemoryMember.cpp
    src/Message.cpp
    src/NodeID.cpp
    src/PipeMember.cpp
    src/PipeMember_private.h
    src/RobotRaconteurNode.cpp
    src/RobotRaconteurNode_connector.cpp
    src/RobotRaconteurNode_connector_private.h
    src/RobotRaconteurServiceIndex_stubskel.cpp
    src/Client.cpp
    src/Service.cpp
    src/Service_lock.cpp
    src/Service_lock_private.h
    src/ServiceStructure.cpp
    src/Security.cpp
    src/ServiceDefinition.cpp
    src/ServiceFactory.cpp
    src/ServiceIndexer.cpp
    src/TcpTransport_private.h
    src/TcpTransport.cpp
    src/Transport.cpp
    src/WireMember.cpp
    src/WireMember_private.h
    src/ASIOStreamBaseTransport.cpp
    src/Timer.cpp
    src/AsyncUtils.cpp
    src/LocalTransport.cpp
    src/LocalTransport_private.h
    src/HardwareTransport.cpp
    src/HardwareTransport_private.h
    src/websocket_stream.hpp
    src/StringTable.cpp
    src/AsyncMessageReader.cpp
    src/AsyncMessageReader.h
    src/AsyncMessageWriter.cpp
    src/AsyncMessageWriter.h
    src/AsyncMessageIO.cpp
    src/Discovery.cpp
    src/Discovery_private.h
    src/Subscription.cpp
    src/Subscription_private.h
    src/Generator.cpp
    src/NodeSetup.cpp
    src/DataTypesPacking.cpp
    src/Logging.cpp
    src/IntraTransport.cpp
    src/Tap.cpp
    src/BroadcastDownsampler.cpp
    src/NodeDirectories.cpp)

set(RobotRaconteurCore_header
    include/RobotRaconteur/RobotRaconteurConfig.h
    include/RobotRaconteur/AutoResetEvent.h
    include/RobotRaconteur/CallbackMember.h
    include/RobotRaconteur/DataTypes.h
    include/RobotRaconteur/Endpoint.h
    include/RobotRaconteur/Error.h
    include/RobotRaconteur/ErrorUtil.h
    include/RobotRaconteur/IOUtils.h
    include/RobotRaconteur/MemoryMember.h
    include/RobotRaconteur/Message.h
    include/RobotRaconteur/NodeID.h
    include/RobotRaconteur/PipeMember.h
    include/RobotRaconteur/RobotRaconteurNode.h
    include/RobotRaconteur/RobotRaconteurServiceIndex.h
    include/RobotRaconteur/RobotRaconteurServiceIndex_stubskel.h
    include/RobotRaconteur/Client.h
    include/RobotRaconteur/Service.h
    include/RobotRaconteur/ServiceStructure.h
    include/RobotRaconteur/Security.h
    include/RobotRaconteur/ServiceDefinition.h
    include/RobotRaconteur/ServiceFactory.h
    include/RobotRaconteur/ServiceIndexer.h
    include/RobotRaconteur/TcpTransport.h
    include/RobotRaconteur/Transport.h
    include/RobotRaconteur/WireMember.h
    include/RobotRaconteur.h
    include/RobotRaconteur/RobotRaconteurConstants.h
    include/RobotRaconteur/AsyncUtils.h
    include/RobotRaconteur/ThreadPool.h
    include/RobotRaconteur/Timer.h
    include/RobotRaconteur/LocalTransport.h
    include/RobotRaconteur/HardwareTransport.h
    include/RobotRaconteur/StringTable.h
    include/RobotRaconteur/AsyncMessageIO.h
    include/RobotRaconteur/Discovery.h
    include/RobotRaconteur/Subscription.h
    include/RobotRaconteur/Generator.h
    include/RobotRaconteur/NodeSetup.h
    include/RobotRaconteur/DataTypesPacking.h
    include/RobotRaconteur/ASIOStreamBaseTransport.h
    include/RobotRaconteur/Logging.h
    include/RobotRaconteur/IntraTransport.h
    include/RobotRaconteur/Tap.h
    include/RobotRaconteur/BroadcastDownsampler.h
    include/RobotRaconteur/NodeDirectories.h)

if(WIN32)
    set(RobotRaconteurCore_src
        ${RobotRaconteurCore_src}
        src/LocalTransport_win.cpp
        src/LocalTransport_win_private.h
        src/HardwareTransport_win.cpp
        src/HardwareTransport_win_private.h
        src/HardwareTransport_usbcommon.cpp
        src/HardwareTransport_usbcommon_private.h
        src/HardwareTransport_bluetoothcommon_private.h
        src/HardwareTransport_discoverycommon_private.h)
endif()

if("${CMAKE_SYSTEM}" MATCHES "Linux" AND NOT ANDROID)
    set(RobotRaconteurCore_src
        ${RobotRaconteurCore_src}
        src/HardwareTransport_linux.cpp
        src/HardwareTransport_linux_private.h
        src/HardwareTransport_usbcommon.cpp
        src/HardwareTransport_usbcommon_private.h
        src/HardwareTransport_libusb.cpp
        src/HardwareTransport_libusb_private.h
        src/LocalTransport_linux.cpp
        src/LocalTransport_linux_private.h)
endif()

if(APPLE)
    set(RobotRaconteurCore_src ${RobotRaconteurCore_src} src/LocalTransport_darwin.cpp
                               src/LocalTransport_darwin_private.h)
endif()

if(WIN32 AND NOT (ROBOTRACONTEUR_USE_OPENSSL))
    set(RobotRaconteurCore_src
        ${RobotRaconteurCore_src} src/TlsSchannelStreamAdapter.cpp src/TlsSchannelStreamAdapter.h
        src/HardwareTransport_win.cpp src/HardwareTransport_win_private.h)
else()
    set(RobotRaconteurCore_src ${RobotRaconteurCore_src} src/OpenSSLAuthContext.cpp src/OpenSSLAuthContext.h)
endif()

if(ANDROID)
    set(RobotRaconteurCore_src ${RobotRaconteurCore_src}) # src/HardwareTransport_usbcommon_private.h
                                                          # src/HardwareTransport_usbcommon.cpp
                                                          # src/HardwareTransport_android_private.h
                                                          # src/HardwareTransport_android.cpp)
endif()

if(BUILD_SHARED_LIBS)
    string(REPLACE "." "." RobotRaconteur_LIB_VERSION ${ROBOTRACONTEUR_VERSION})
    set(RobotRaconteur_SHARED_CORE_VERSION "${RobotRaconteur_LIB_VERSION}")
endif()

if(BUILD_SHARED_LIBS)
    set(CMAKE_DEBUG_POSTFIX "d")
    add_library(RobotRaconteurCore SHARED ${RobotRaconteurCore_src} ${RobotRaconteurCore_header})
    set_target_properties(
        RobotRaconteurCore
        PROPERTIES VERSION "${RobotRaconteur_SHARED_CORE_VERSION}" SOVERSION "${RobotRaconteur_SHARED_CORE_VERSION}"
                   COMPILE_DEFINITIONS "ROBOTRACONTEUR_CORE_EXPORTS")
else()
    add_library(RobotRaconteurCore STATIC ${RobotRaconteurCore_src} ${RobotRaconteurCore_header})
    set_target_properties(RobotRaconteurCore PROPERTIES PREFIX lib)
endif()

target_link_libraries(
    RobotRaconteurCore
    PUBLIC Boost::boost
           Boost::disable_autolinking
           Boost::date_time
           Boost::filesystem
           Boost::system
           Boost::regex
           Boost::chrono
           Boost::atomic
           Boost::thread
           Boost::random
           Boost::program_options)

if(RobotRaconteur_DISABLE_MESSAGE4)
    target_compile_definitions(RobotRaconteurCore PRIVATE ROBOTRACONTEUR_DISABLE_MESSAGE4)
endif()
if(RobotRaconteur_DISABLE_STRINGTABLE)
    target_compile_definitions(RobotRaconteurCore PRIVATE ROBOTRACONTEUR_DISABLE_STRINGTABLE)
endif()

if(WIN32)
    target_compile_definitions(RobotRaconteurCore PUBLIC _WIN32_WINNT=0x0600 NOMINMAX=1)
    if(ROBOTRACONTEUR_USE_OPENSSL)
        target_link_libraries(
            RobotRaconteurCore
            PRIVATE Mswsock.lib
                    ws2_32.lib
                    IPHLPAPI.lib
                    Bcrypt.lib
                    Crypt32.lib
                    OpenSSL::SSL
                    OpenSSL::Crypto)
        target_compile_definitions(RobotRaconteurCore PRIVATE ROBOTRACONTEUR_USE_OPENSSL)
    else()
        target_link_libraries(
            RobotRaconteurCore
            PRIVATE Mswsock.lib
                    ws2_32.lib
                    IPHLPAPI.lib
                    Bcrypt.lib
                    Crypt32.lib
                    Secur32.lib
                    Bcrypt.lib)
        target_compile_definitions(RobotRaconteurCore PRIVATE ROBOTRACONTEUR_USE_SCHANNEL)
    endif()

    if(CMAKE_COMPILER_IS_GNUCXX)
        target_compile_options(RobotRaconteurCore PRIVATE "-mthreads")
    endif()

    if(BUILD_SHARED_LIBS)
        target_compile_definitions(RobotRaconteurCore PRIVATE ROBOTRACONTEUR_CORE_EXPORTS
                                   INTERFACE ROBOTRACONTEUR_CORE_IMPORTS)
    endif()
endif()

if(APPLE)
    target_link_libraries(RobotRaconteurCore PRIVATE "${COREFOUNDATION_FRAMEWORK}" "${SECURITY_FRAMEWORK}"
                                                     "${CORESERVICES_FRAMEWORK}" OpenSSL::SSL OpenSSL::Crypto c++)
    target_compile_definitions(RobotRaconteurCore PRIVATE ROBOTRACONTEUR_USE_OPENSSL)
endif()

if(UNIX AND NOT APPLE AND NOT ANDROID)
    target_include_directories(RobotRaconteurCore PRIVATE ${DBUS_INCLUDE_DIR} ${DBUS_INCLUDE_ARCH_DIR}
                                                          ${LIBUSB_INCLUDE_DIR})
    target_link_libraries(RobotRaconteurCore PRIVATE OpenSSL::SSL OpenSSL::Crypto pthread rt z dl)
    target_compile_definitions(RobotRaconteurCore PRIVATE ROBOTRACONTEUR_USE_OPENSSL)
endif()

if(ANDROID)
    target_include_directories(RobotRaconteurCore PRIVATE ${LIBUSB_INCLUDE_DIR})
    target_link_libraries(RobotRaconteurCore PRIVATE OpenSSL::SSL OpenSSL::Crypto)
    target_compile_definitions(RobotRaconteurCore PRIVATE ROBOTRACONTEUR_USE_OPENSSL)
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
    target_compile_options(RobotRaconteurCore PRIVATE "-fPIC")
endif()

if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    target_compile_options(RobotRaconteurCore PRIVATE "-fPIC")
endif()

if(MSVC)
    target_compile_options(RobotRaconteurCore PRIVATE "/wd4251" "/wd4275" "/bigobj")
endif()

target_include_directories(
    RobotRaconteurCore PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>
                              $<INSTALL_INTERFACE:include/> # <prefix>/include/
)

if(${CMAKE_VERSION} VERSION_GREATER "3.16.0")
    target_precompile_headers(RobotRaconteurCore PRIVATE ${RobotRaconteurCore_header})
    set_source_files_properties(src/LocalTransport.cpp PROPERTIES SKIP_PRECOMPILE_HEADERS TRUE)

=== RobotRaconteurGen/CMakeLists.txt ===
set(RobotRaconteurGen_src
    CPPServiceLangGen.cpp CSharpServiceLangGen.cpp
    # VBNETServiceLangGen.cpp
    JavaServiceLangGen.cpp RobotRaconteurGen.cpp StringTableGen.cpp)

set(RobotRaconteurGen_header
    CPPServiceLangGen.h CSharpServiceLangGen.h
    # VBNETServiceLangGen.h
    JavaServiceLangGen.h StringTableGen.h)

add_executable(RobotRaconteurGen ${RobotRaconteurGen_src} ${RobotRaconteurGen_header})

if(${CMAKE_VERSION} VERSION_GREATER "3.16.0")
    target_precompile_headers(RobotRaconteurGen PRIVATE ${RobotRaconteurGen_header})
endif()

# if(ROBOTRACONTEUR_ROS) find_package(roslib REQUIRED) target_link_libraries(RobotRaconteurGen PRIVATE
# RobotRaconteurCore ${roslib_LIBRARIES}) target_include_directories(RobotRaconteurGen PRIVATE ${roslib_INCLUDE_DIRS})
# target_compile_definitions(RobotRaconteurGen PRIVATE ROBOTRACONTEUR_ROS) else()
target_link_libraries(RobotRaconteurGen RobotRaconteurCore)
# endif()

rrsettargetdirs(RobotRaconteurGen "bin" "lib")

rrconfiguretest(gen_prog "${CMAKE_BINARY_DIR}/@OUT_DIR_NAME@/bin/RobotRaconteurGen" "test_prog" NOCTEST)
# RRConfigureTest(test_cpp_loopback "${CMAKE_BINARY_DIR}/@OUT_DIR_NAME@/bin/RobotRaconteurTest" "test_prog" ARGS
# "loopback")

set(RR_TEST_ROBDEFS com.robotraconteur.testing.TestService1.robdef com.robotraconteur.testing.TestService2.robdef
                    com.robotraconteur.testing.TestService3.robdef)

function(RR_TEST_GEN lang)
    string(REPLACE ";" " " RR_TEST_ROBDEFS_1 "${RR_TEST_ROBDEFS}")
    set(RR_TEST_GEN_CMD "${CMAKE_BINARY_DIR}/@OUT_DIR_NAME@/bin/RobotRaconteurGen")
    set(RR_TEST_GEN_CMD_ARGS
        "--thunksource --lang=${lang} -I ${CMAKE_SOURCE_DIR}/test/robdef --output-dir ${CMAKE_CURRENT_BINARY_DIR}/gen/@OUT_DIR_NAME@/${lang} ${RR_TEST_ROBDEFS_1}"
    )

    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/gen/out/${lang}")
    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/gen/out_debug/${lang}")
    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/gen/out_reldebug/${lang}")

    set(GEN_FILE_LIST "")

    file(GLOB_RECURSE ROBOTRACONTEUR_GEN_TEST_FILES RELATIVE "${CMAKE_SOURCE_DIR}/test/gen/${lang}"
         "${CMAKE_SOURCE_DIR}/test/gen/${lang}/*")
    foreach(F ${ROBOTRACONTEUR_GEN_TEST_FILES})
        if(WIN32)
            configure_file("${CMAKE_SOURCE_DIR}/test/gen/${lang}/${F}"
                           "${CMAKE_CURRENT_BINARY_DIR}/gen/test/${lang}/${F}" NEWLINE_STYLE CRLF)
        else()
            configure_file("${CMAKE_SOURCE_DIR}/test/gen/${lang}/${F}"
                           "${CMAKE_CURRENT_BINARY_DIR}/gen/test/${lang}/${F}" NEWLINE_STYLE LF)
        endif()
        set(GEN_FILE_LIST
            "${GEN_FILE_LIST}\"${CMAKE_CURRENT_BINARY_DIR}/gen/test/${lang}/${F};${CMAKE_CURRENT_BINARY_DIR}/gen/@OUT_DIR_NAME@/${lang}/${F}\","
        )
    endforeach()

    rrconfiguretest(
        "test_gen_${lang}"
        "${RR_TEST_GEN_CMD}"
        "test_gen"
        ARGS
        "${RR_TEST_GEN_CMD_ARGS}"
        FILELIST
        GEN_FILE_LIST)
endfunction()

rr_test_gen(cpp)
rr_test_gen(csharp)
rr_test_gen(java)

export(TARGETS RobotRaconteurGen FILE ${CMAKE_BINARY_DIR}/RobotRaconteurGenTargets.cmake)
install(TARGETS RobotRaconteurGen EXPORT RobotRaconteurGenTargets DESTINATION ${CMAKE_INSTALL_BINDIR})
install(EXPORT RobotRaconteurGenTargets DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${CMAKE_PROJECT_NAME})
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/RobotRaconteurGenerateThunk.cmake
               ${CMAKE_BINARY_DIR}/RobotRaconteurGenerateThunk.cmake @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/RobotRaconteurGenerateThunk.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${CMAKE_PROJECT_NAME})

=== RobotRaconteurJava/CMakeLists.txt ===
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/exceptionsrc)

if(NOT ANDROID)
    include(FindJava)
    find_package(Java COMPONENTS Development)
    include(UseJava)
    include(FindJNI)
    find_package(JNI)

    include_directories(${JNI_INCLUDE_DIRS})
else()
    include(FindJava)
    find_package(Java COMPONENTS Development)
endif()

if(ANDROID)
    set(LIBUSB_INCLUDE_DIR "" CACHE PATH "Path to libusb.h for android")
endif()

if(NOT USE_PREGENERATED_SOURCE)

    include(FindSWIG)
    find_package(SWIG 4.0.2 REQUIRED)
    include(${CMAKE_SOURCE_DIR}/cmake/RRUseSwig.cmake)

    include(JavaSwigVars.cmake)
    set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR}/swigsrc/com/robotraconteur)
    include_directories(${CMAKE_SOURCE_DIR}/RobotRaconteurCore/include)
    rr_swig_add_module(
        RobotRaconteurJavaNative java RobotRaconteurJava.i ${CMAKE_SOURCE_DIR}/SWIG/RobotRaconteurWrapped.cpp
        ${CMAKE_SOURCE_DIR}/SWIG/RobotRaconteurWrapped.h)

    swig_link_libraries(RobotRaconteurJavaNative RobotRaconteurCore)

else()
    set(SWIG_MODULE_RobotRaconteurJavaNative_REAL_NAME RobotRaconteurJavaNative)

    if("${SIZEOF_LONG_INT}" EQUAL 8 AND CMAKE_COMPILER_IS_GNUCXX)
        set(CMAKE_SWIG_OUTDIR ${PREGENERATED_SOURCE_DIR}/Java/swigwordsize64/com/robotraconteur)
    else()
        set(CMAKE_SWIG_OUTDIR ${PREGENERATED_SOURCE_DIR}/Java/swigwordsize32/com/robotraconteur)
    endif()
    include_directories(${CMAKE_SOURCE_DIR}/SWIG ${CMAKE_SWIG_OUTDIR})
    add_library(
        RobotRaconteurJavaNative MODULE
        ${CMAKE_SOURCE_DIR}/SWIG/RobotRaconteurWrapped.cpp ${CMAKE_SOURCE_DIR}/SWIG/RobotRaconteurWrapped.h
        ${CMAKE_SWIG_OUTDIR}/RobotRaconteurJavaJAVA_wrap.cxx)
    target_link_libraries(RobotRaconteurJavaNative RobotRaconteurCore)

endif()

if(MSVC)
    target_compile_options(${SWIG_MODULE_RobotRaconteurJavaNative_REAL_NAME} PRIVATE "/bigobj")
endif()

target_compile_definitions(${SWIG_MODULE_RobotRaconteurJavaNative_REAL_NAME}
                           PRIVATE SWIG_TYPE_TABLE=robotraconteur_java)

if(APPLE)
    set_target_properties(RobotRaconteurJavaNative PROPERTIES SUFFIX ".jnilib")
endif()
if((WIN32 AND MINGW) OR CYGWIN OR CMAKE_SYSTEM_NAME STREQUAL MSYS)
    set_target_properties(RobotRaconteurJavaNative PROPERTIES PREFIX "")
endif()

rrsettargetdirs(RobotRaconteurJavaNative "Java" "Java")

if(NOT ANDROID)
    add_custom_target(
        RobotRaconteurJava ALL
        "${Java_JAVAC_EXECUTABLE}"
        -encoding
        UTF8
        -g:none
        -target
        7
        -source
        7
        -Xlint:none
        com/robotraconteur/*.java
        ${CMAKE_SWIG_OUTDIR}/*.java
        ${CMAKE_CURRENT_BINARY_DIR}/exceptionsrc/com/robotraconteur/*.java
        -d
        "${CMAKE_CURRENT_BINARY_DIR}/bin"
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/src")
    add_custom_command(
        TARGET RobotRaconteurJava
        POST_BUILD
        COMMAND "${Java_JAR_EXECUTABLE}" cf "$<TARGET_FILE_DIR:RobotRaconteurJavaNative>/RobotRaconteur.jar" *
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bin")
else()
    set(ANDROID_JAR "" CACHE FILEPATH "Android system Jar file")
    add_custom_target(
        RobotRaconteurJava ALL
        "${Java_JAVAC_EXECUTABLE}"
        -encoding
        UTF8
        -g:none
        -target
        7
        -source
        7
        -Xlint:none
        com/robotraconteur/*.java
        ${CMAKE_SWIG_OUTDIR}/*.java
        ${CMAKE_CURRENT_BINARY_DIR}/exceptionsrc/com/robotraconteur/*.java
        -d
        "${CMAKE_CURRENT_BINARY_DIR}/bin"
        -cp
        "${ANDROID_JAR}"
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/src")
    add_custom_command(
        TARGET RobotRaconteurJava
        POST_BUILD
        COMMAND "${Java_JAR_EXECUTABLE}" cf "$<TARGET_FILE_DIR:RobotRaconteurJavaNative>/RobotRaconteurAndroid.jar" *
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bin")
endif()

include(${CMAKE_SOURCE_DIR}/RobotRaconteurGen/cmake/RobotRaconteurGenerateThunk.cmake)

set_target_properties(RobotRaconteurJavaNative PROPERTIES OUTPUT_NAME "RobotRaconteurJavaNative")

if(NOT DEFINED RobotRaconteur_DIR)
    add_dependencies(RobotRaconteurJavaNative RobotRaconteurCore)
endif()

add_dependencies(RobotRaconteurJava RobotRaconteurJavaNative)

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        set_target_properties(RobotRaconteurJavaNative PROPERTIES OUTPUT_NAME "RobotRaconteurJavaNative-win64")
    else()
        set_target_properties(RobotRaconteurJavaNative PROPERTIES OUTPUT_NAME "RobotRaconteurJavaNative-win32")
    endif()
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

    message(STATUS "Detected system processor ${CMAKE_SYSTEM_PROCESSOR}")

    if(CMAKE_SYSTEM_PROCESSOR MATCHES "^arm.*")
        # Assume hard float for arm
        set_target_properties(RobotRaconteurJavaNative PROPERTIES OUTPUT_NAME "RobotRaconteurJavaNative-linux-armhf")
    elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "arm64" OR CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
        set_target_properties(RobotRaconteurJavaNative PROPERTIES OUTPUT_NAME "RobotRaconteurJavaNative-linux-arm64")
    else()

        if(CMAKE_SIZEOF_VOID_P EQUAL 8)
            set_target_properties(RobotRaconteurJavaNative PROPERTIES OUTPUT_NAME "RobotRaconteurJavaNative-linux64")
        else()
            set_target_properties(RobotRaconteurJavaNative PROPERTIES OUTPUT_NAME "RobotRaconteurJavaNative-linux32")
        endif()
    endif()
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

    set_target_properties(RobotRaconteurJavaNative PROPERTIES OUTPUT_NAME "RobotRaconteurJavaNative-darwin")

endif()

if(ANDROID)

    set_target_properties(RobotRaconteurJavaNative PROPERTIES OUTPUT_NAME "RobotRaconteurJavaNative-android")

endif()

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/Manifest.txt.in" "${CMAKE_CURRENT_BINARY_DIR}/bin/Manifest.txt" @ONLY)

include("${CMAKE_CURRENT_SOURCE_DIR}/JavaExceptions.cmake")

=== RobotRaconteurNET/CMakeLists.txt ===
if(NOT USE_PREGENERATED_SOURCE)

    include(FindSWIG)
    find_package(SWIG 4.0.2 REQUIRED)
    include(${CMAKE_SOURCE_DIR}/cmake/RRUseSwig.cmake)

    include(NETSwigVars.cmake)
    include_directories(${CMAKE_SOURCE_DIR}/RobotRaconteurCore/include)
    rr_swig_add_module(RobotRaconteurNETNative csharp ${CMAKE_SOURCE_DIR}/SWIG/RobotRaconteurWrapped.cpp
                       ${CMAKE_SOURCE_DIR}/SWIG/RobotRaconteurWrapped.h RobotRaconteurNET.i)

    swig_link_libraries(RobotRaconteurNETNative RobotRaconteurCore)
else()
    set(SWIG_MODULE_RobotRaconteurNETNative_REAL_NAME RobotRaconteurNETNative)

    if("${SIZEOF_LONG_INT}" EQUAL 8 AND CMAKE_COMPILER_IS_GNUCXX)
        set(CMAKE_SWIG_OUTDIR ${PREGENERATED_SOURCE_DIR}/NET/swigwordsize64/)
    else()
        set(CMAKE_SWIG_OUTDIR ${PREGENERATED_SOURCE_DIR}/NET/swigwordsize32/)
    endif()
    include_directories(${CMAKE_SOURCE_DIR}/SWIG ${CMAKE_SWIG_OUTDIR})
    add_library(
        RobotRaconteurNETNative MODULE
        ${CMAKE_SOURCE_DIR}/SWIG/RobotRaconteurWrapped.cpp ${CMAKE_SOURCE_DIR}/SWIG/RobotRaconteurWrapped.h
        ${CMAKE_SWIG_OUTDIR}/RobotRaconteurNETCSHARP_wrap.cxx)
    target_link_libraries(RobotRaconteurNETNative RobotRaconteurCore)
endif()
# if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/RobotRaconteurNET_wrap.cxx")

if(MSVC)
    target_compile_options(${SWIG_MODULE_RobotRaconteurNETNative_REAL_NAME} PRIVATE "/bigobj")
endif()

if(APPLE)
    set_target_properties(${SWIG_MODULE_RobotRaconteurNETNative_REAL_NAME} PROPERTIES SUFFIX ".dylib")
endif()

target_compile_definitions(${SWIG_MODULE_RobotRaconteurNETNative_REAL_NAME} PRIVATE SWIG_TYPE_TABLE=robotraconteur_net)

rrsettargetdirs(${SWIG_MODULE_RobotRaconteurNETNative_REAL_NAME} "NET/Native" "NET/Native")

# get_target_property(outdir RobotRaconteurNETNative LIBRARY_OUTPUT_DIRECTORY) get_target_property(outdir
# RobotRaconteurNETNative RUNTIME_OUTPUT_DIRECTORY_DEBUG)

set(RR_NET_PLATFORM_SUFFIX FALSE CACHE BOOL "")
if(RR_NET_PLATFORM_SUFFIX)
    set_target_properties(${SWIG_MODULE_RobotRaconteurNETNative_REAL_NAME} PROPERTIES OUTPUT_NAME
                                                                                      "RobotRaconteurNETNative")
    if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
        if(CMAKE_SIZEOF_VOID_P EQUAL 8)
            set_target_properties(${SWIG_MODULE_RobotRaconteurNETNative_REAL_NAME}
                                  PROPERTIES OUTPUT_NAME "RobotRaconteurNETNative-linux64")
        else()
            set_target_properties(${SWIG_MODULE_RobotRaconteurNETNative_REAL_NAME}
                                  PROPERTIES OUTPUT_NAME "RobotRaconteurNETNative-linux32")
        endif()
    endif()

    if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

        set_target_properties(${SWIG_MODULE_RobotRaconteurNETNative_REAL_NAME}
                              PROPERTIES OUTPUT_NAME "RobotRaconteurNETNative-darwin")
    endif()
else()
    set_target_properties(${SWIG_MODULE_RobotRaconteurNETNative_REAL_NAME} PROPERTIES PREFIX
                                                                                      "${CMAKE_SHARED_MODULE_PREFIX}")
endif()

set(RR_NET_INSTALL_NATIVE_LIB OFF CACHE BOOL "Install .NET Native lib")
mark_as_advanced(RR_NET_INSTALL_NATIVE_LIB)

if(RR_NET_INSTALL_NATIVE_LIB)
    install(TARGETS ${SWIG_MODULE_RobotRaconteurNETNative_REAL_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

set(RR_NET_BUILD_NATIVE_ONLY OFF CACHE BOOL "Install .NET Native lib")
mark_as_advanced(RR_NET_BUILD_NATIVE_ONLY)

if(NOT RR_NET_BUILD_NATIVE_ONLY)

    include("${CMAKE_CURRENT_SOURCE_DIR}/NETExceptions.cmake")

    if(WIN32)
        add_custom_target(
            RobotRaconteurNET ALL
            msbuild $<$<CONFIG:debug>:/p:Configuration=Debug>$<$<CONFIG:release>:/p:Configuration=Release> /t:rebuild
            /nowarn:CS1591 RobotRaconteurNET.csproj WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
    else()
        find_program(XBUILD_EXECUTABLE NAMES xbuild msbuild)
        add_custom_target(
            RobotRaconteurNET ALL
            "${XBUILD_EXECUTABLE}"
            $<$<CONFIG:debug>:/p:Configuration=Debug>$<$<CONFIG:release>:/p:Configuration=Release>
            RobotRaconteurNET.csproj
            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
    endif()
    add_dependencies(RobotRaconteurNET RobotRaconteurNETNative)

    add_custom_command(
        TARGET RobotRaconteurNET POST_BUILD
        COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/xml_doc/merge_doc_xml.cmake
                $<$<CONFIG:debug>:Debug>$<$<CONFIG:release>:Release>)

    set(RR_NET_BUILT_DOC_XML "${CMAKE_CURRENT_BINARY_DIR}/xml_doc/RobotRaconteurNET_built_doc.xml ")
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/merge_doc_xml.cmake.in
                   ${CMAKE_CURRENT_BINARY_DIR}/xml_doc/merge_doc_xml.cmake @ONLY)
    set(RR_NET_DLL_DIR "${CMAKE_BINARY_DIR}/out/NET")
    configure_file(${CMAKE_SOURCE_DIR}/docs/net/docfx.json.in ${CMAKE_BINARY_DIR}/out/NET/docs/docfx.json @ONLY)
    configure_file(${CMAKE_SOURCE_DIR}/docs/net/generate_docfx_filter_config.cmake.in
                   ${CMAKE_BINARY_DIR}/out/NET/docs/generate_docfx_filter_config.cmake @ONLY)
    set(RR_NET_DLL_DIR "${CMAKE_BINARY_DIR}/out_debug/NET")
    configure_file(${CMAKE_SOURCE_DIR}/docs/net/docfx.json.in ${CMAKE_BINARY_DIR}/out_debug/NET/docs/docfx.json @ONLY)
    configure_file(${CMAKE_SOURCE_DIR}/docs/net/generate_docfx_filter_config.cmake.in
                   ${CMAKE_BINARY_DIR}/out_debug/NET/docs/generate_docfx_filter_config.cmake @ONLY)

    if(BUILD_DOCUMENTATION)
        find_program(DOCFX_EXECUTABLE NAMES docfx)

        if(NOT DOCFX_EXECUTABLE)
            message(FATAL_ERROR "docfx is required to build csharp documentation")
        endif()

        file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/docs/net)

        add_custom_target(
            RobotRaconteurNET_doc
            COMMAND ${CMAKE_COMMAND} -P generate_docfx_filter_config.cmake
            COMMAND
                ${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/docs/net/source/index.md
                ${CMAKE_SOURCE_DIR}/docs/net/source/toc.yml
                $<TARGET_FILE_DIR:${SWIG_MODULE_RobotRaconteurNETNative_REAL_NAME}>/../docs
            COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}/docs/net/source/articles
                    $<TARGET_FILE_DIR:${SWIG_MODULE_RobotRaconteurNETNative_REAL_NAME}>/../docs/articles
            COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}/docs/net/source/images
                    $<TARGET_FILE_DIR:${SWIG_MODULE_RobotRaconteurNETNative_REAL_NAME}>/../docs/images
            COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}/docs/net/source/api
                    $<TARGET_FILE_DIR:${SWIG_MODULE_RobotRaconteurNETNative_REAL_NAME}>/../docs/api
            COMMAND ${DOCFX_EXECUTABLE} metadata
            COMMAND ${DOCFX_EXECUTABLE} build --output ${CMAKE_BINARY_DIR}/docs
            WORKING_DIRECTORY $<TARGET_FILE_DIR:${SWIG_MODULE_RobotRaconteurNETNative_REAL_NAME}>/../docs
            COMMENT "Generating csharp documentation yaml"
            DEPENDS RobotRaconteurNET)

    endif()

    if(WIN32)
        if(CMAKE_SIZEOF_VOID_P EQUAL 8)
            set(RR_PREFER_32BIT "<Prefer32Bit>false</Prefer32Bit>")
        else()
            set(RR_PREFER_32BIT "<Prefer32Bit>true</Prefer32Bit>")
        endif()
    endif()

    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/RobotRaconteurNET/RobotRaconteurNET.csproj.in"
                   "${CMAKE_CURRENT_BINARY_DIR}/RobotRaconteurNET.csproj" @ONLY)

    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/RobotRaconteurNET/netstandard/RobotRaconteurNET.csproj.in"
                   "${CMAKE_CURRENT_BINARY_DIR}/netstandard/Lib/RobotRaconteurNET.csproj" @ONLY)

    if(WIN32 AND (MSVC_VERSION GREATER 1900))
        add_custom_target(
            RobotRaconteurNET_standard ALL
            msbuild /restore /verbosity:quiet
            $<$<CONFIG:debug>:/p:Configuration=Debug>$<$<CONFIG:release>:/p:Configuration=Release> /t:rebuild
            RobotRaconteurNET.csproj
            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/netstandard/Lib")
        add_custom_command(
            TARGET RobotRaconteurNET_standard
            POST_BUILD
            COMMAND
            COMMAND ${CMAKE_COMMAND} -E make_directory
                    ${CMAKE_BINARY_DIR}/$<$<CONFIG:debug>:out_debug>$<$<CONFIG:release>:out>/NET/netstandard
            COMMAND
                ${CMAKE_COMMAND} -E copy
                ${CMAKE_CURRENT_BINARY_DIR}/netstandard/Lib/bin/$<$<CONFIG:debug>:Debug>$<$<CONFIG:release>:Release>/RobotRaconteurNET.dll
                ${CMAKE_BINARY_DIR}/$<$<CONFIG:debug>:out_debug>$<$<CONFIG:release>:out>/NET/netstandard/.)
        add_dependencies(RobotRaconteurNET_standard RobotRaconteurNETNative)

        add_custom_command(
            TARGET RobotRaconteurNET_standard POST_BUILD
            COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/xml_doc/netstandard/merge_doc_xml.cmake
                    $<$<CONFIG:debug>:Debug>$<$<CONFIG:release>:Release> netstandard)

        set(RR_NET_BUILT_DOC_XML "${CMAKE_CURRENT_BINARY_DIR}/xml_doc/netstandard/RobotRaconteurNET_built_doc.xml ")
        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/merge_doc_xml.cmake.in
                       ${CMAKE_CURRENT_BINARY_DIR}/xml_doc/netstandard/merge_doc_xml.cmake @ONLY)
    endif()

    string(TIMESTAMP CurrentYear "%Y")

    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/RobotRaconteurNET/Properties/AssemblyInfo.cs.in"
                   "${CMAKE_CURRENT_BINARY_DIR}/AssemblyInfo.cs" @ONLY)

endif()

=== RobotRaconteurPython/CMakeLists.txt ===
set(Python_ADDITIONAL_VERSIONS 2.7)

find_package(PythonInterp REQUIRED)
find_package(PythonLibs REQUIRED)

find_path(NUMPY_INCLUDE_NDARRAYOBJECT_DIR numpy/ndarrayobject.h PATHS ${PYTHON_INCLUDE_DIRS} NO_DEFAULT_PATH)
if(NUMPY_INCLUDE_NDARRAYOBJECT_DIR)
    set(NUMPY_INCLUDE_DIR ${NUMPY_INCLUDE_NDARRAYOBJECT_DIR})
else()
    execute_process(
        COMMAND ${PYTHON_EXECUTABLE} -c
                "import numpy; import os; print(os.path.dirname(numpy.__file__) + '/core/include')"
        RESULT_VARIABLE FIND_NUMPY_RESULT OUTPUT_VARIABLE NUMPY_INCLUDE_DIR)
    string(STRIP "${NUMPY_INCLUDE_DIR}" NUMPY_INCLUDE_DIR)

    if(${FIND_NUMPY_RESULT})
        message(FATAL_ERROR "Could not determine NumPy include directory")
    endif()
endif()

if(NOT EXISTS "${NUMPY_INCLUDE_DIR}/numpy/ndarrayobject.h")
    message(FATAL_ERROR "Could not find numpy/ndarrayobject.h include file")
endif()

message(STATUS "NumPy Include Directory: ${NUMPY_INCLUDE_DIR}")

include(PythonPackageVersion.cmake)

get_filename_component(PYTHON_LINK_DIRS "${PYTHON_LIBRARIES}" DIRECTORY)
link_directories(${PYTHON_LINK_DIRS})

if(NOT USE_PREGENERATED_SOURCE)
    include(FindSWIG)
    find_package(SWIG 4.0.2 REQUIRED)
    include(${CMAKE_SOURCE_DIR}/cmake/RRUseSwig.cmake)
    include(PythonSwigVars.cmake)
    set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR})
    include_directories(${CMAKE_SOURCE_DIR}/RobotRaconteurCore/include)
    rr_swig_add_module(
        RobotRaconteurPython
        python
        RobotRaconteurPython.i
        ${CMAKE_SOURCE_DIR}/SWIG/RobotRaconteurWrapped.cpp
        ${CMAKE_SOURCE_DIR}/SWIG/RobotRaconteurWrapped.h
        PythonTypeSupport.cpp
        PythonTypeSupport.h)
    swig_link_libraries(RobotRaconteurPython RobotRaconteurCore)
else()
    set(SWIG_MODULE_RobotRaconteurPython_REAL_NAME _RobotRaconteurPython)

    if("${SIZEOF_LONG_INT}" EQUAL 8 AND CMAKE_COMPILER_IS_GNUCXX)
        set(CMAKE_SWIG_OUTDIR ${PREGENERATED_SOURCE_DIR}/Python/swigwordsize64/)
    else()
        set(CMAKE_SWIG_OUTDIR ${PREGENERATED_SOURCE_DIR}/Python/swigwordsize32/)
    endif()
    include_directories(${CMAKE_SOURCE_DIR}/SWIG ${CMAKE_SWIG_OUTDIR})
    add_library(
        _RobotRaconteurPython MODULE
        ${CMAKE_SOURCE_DIR}/SWIG/RobotRaconteurWrapped.cpp ${CMAKE_SOURCE_DIR}/SWIG/RobotRaconteurWrapped.h
        PythonTypeSupport.cpp PythonTypeSupport.h ${CMAKE_SWIG_OUTDIR}/RobotRaconteurPythonPYTHON_wrap.cxx)
    target_link_libraries(_RobotRaconteurPython RobotRaconteurCore)
    set_target_properties(_RobotRaconteurPython PROPERTIES PREFIX "")
endif()

target_compile_definitions(
    ${SWIG_MODULE_RobotRaconteurPython_REAL_NAME} PRIVATE RR_PYTHON NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION
                                                          SWIG_TYPE_TABLE=robotraconteur_python)
target_include_directories(
    ${SWIG_MODULE_RobotRaconteurPython_REAL_NAME} PRIVATE ${PYTHON_INCLUDE_DIRS} ${CMAKE_SOURCE_DIR}/SWIG
                                                          ${CMAKE_CURRENT_SOURCE_DIR} ${NUMPY_INCLUDE_DIR})

if(MSVC)
    target_compile_options(${SWIG_MODULE_RobotRaconteurPython_REAL_NAME} PRIVATE "/bigobj")
endif()

rrsettargetdirs(${SWIG_MODULE_RobotRaconteurPython_REAL_NAME} "Python/RobotRaconteur" "Python/RobotRaconteur")

if(WIN32)
    set_target_properties(${SWIG_MODULE_RobotRaconteurPython_REAL_NAME} PROPERTIES SUFFIX ".pyd")
    set_target_properties(${SWIG_MODULE_RobotRaconteurPython_REAL_NAME} PROPERTIES EXCLUDE_FROM_DEFAULT_BUILD_DEBUG
                                                                                   TRUE)
else()
    set_target_properties(${SWIG_MODULE_RobotRaconteurPython_REAL_NAME} PROPERTIES SUFFIX ".so")
endif()

if(NOT DEFINED RobotRaconteur_DIR)
    add_dependencies(${SWIG_MODULE_RobotRaconteurPython_REAL_NAME} RobotRaconteurCore)
endif()

add_custom_command(
    TARGET ${SWIG_MODULE_RobotRaconteurPython_REAL_NAME} POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SWIG_OUTDIR}/RobotRaconteurPython.py
            $<TARGET_FILE_DIR:${SWIG_MODULE_RobotRaconteurPython_REAL_NAME}>/)
add_custom_command(
    TARGET ${SWIG_MODULE_RobotRaconteurPython_REAL_NAME} POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/RobotRaconteurPythonError.py
            $<TARGET_FILE_DIR:${SWIG_MODULE_RobotRaconteurPython_REAL_NAME}>/)

file(GLOB RR_PY_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/*.py)
foreach(P ${RR_PY_SOURCES})
    get_filename_component(P_NAME ${P} NAME)
    set(P2 ${P})
    set(P3 $<SHELL_PATH:$<TARGET_FILE_DIR:${SWIG_MODULE_RobotRaconteurPython_REAL_NAME}>>/${P_NAME})
    set(PYTHON_COPY_COMMAND ${CMAKE_COMMAND} -E copy)
    if(MSVC)
        set(PYTHON_USE_HARD_LINKS "" CACHE BOOL "Use hard links for Python copy")
        if(PYTHON_USE_HARD_LINKS)
            set(PYTHON_COPY_COMMAND mklink /h)
            set(P2 ${P3})
            set(P3 ${P})
            string(REPLACE "/" "\\" P2 ${P2})
            string(REPLACE "/" "\\" P3 ${P3})
            add_custom_command(TARGET ${SWIG_MODULE_RobotRaconteurPython_REAL_NAME} POST_BUILD COMMAND del ${P2})
        endif()
    endif()
    add_custom_command(TARGET ${SWIG_MODULE_RobotRaconteurPython_REAL_NAME} POST_BUILD COMMAND ${PYTHON_COPY_COMMAND}
                                                                                               ${P2} ${P3})
endforeach(P)

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in" "${CMAKE_BINARY_DIR}/out/Python/setup.py" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in" "${CMAKE_BINARY_DIR}/out_debug/Python/setup.py" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in" "${CMAKE_BINARY_DIR}/out_reldebug/Python/setup.py" @ONLY)

set(PYTHON2_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
include("${CMAKE_CURRENT_SOURCE_DIR}/PythonExceptions.cmake")

set(BUILD_PYTHON_WHEEL OFF CACHE BOOL "Enable building Python 2 wheels")
if(BUILD_PYTHON_WHEEL)
    add_custom_target(
        RobotRaconteurPython_Wheel ALL
        ${CMAKE_COMMAND}
        -E
        chdir
        "$<TARGET_FILE_DIR:${SWIG_MODULE_RobotRaconteurPython_REAL_NAME}>/.."
        "${PYTHON_EXECUTABLE}"
        setup.py
        bdist_wheel
        DEPENDS ${SWIG_MODULE_RobotRaconteurPython_REAL_NAME})
    if(WIN32)
        set_target_properties(RobotRaconteurPython_Wheel PROPERTIES EXCLUDE_FROM_DEFAULT_BUILD_DEBUG TRUE)
    endif()
endif()

# This mess is taken from github.com/ros/catkin/cmake/python.cmake...
set(enable_setuptools_deb_layout OFF)
if(ROBOTRACONTEUR_ROS)
    if(EXISTS "/etc/debian_version")
        set(enable_setuptools_deb_layout ON)
    endif()
endif()

option(SETUPTOOLS_DEB_LAYOUT "Enable debian style python package layout" ${enable_setuptools_deb_layout})
if(SETUPTOOLS_DEB_LAYOUT)
    message(STATUS "Using Debian Python package layout")
    set(SETUPTOOLS_ARG_EXTRA "--install-layout=deb")
endif()

option(INSTALL_PYTHON "Install Python library" OFF)
if(ROBOTRACONTEUR_ROS OR ROBOTRACONTEUR_COLCON OR INSTALL_PYTHON)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/python_install.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/python_install.cmake
                   @ONLY)
    install(SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/python_install.cmake)
endif()

=== RobotRaconteurPython3/CMakeLists.txt ===
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/Modules)

find_package(PythonInterp3 REQUIRED)
find_package(PythonLibs3 REQUIRED)

set(PYTHON2_SOURCE_DIR "${CMAKE_SOURCE_DIR}/RobotRaconteurPython")

find_path(NUMPY3_INCLUDE_NDARRAYOBJECT_DIR numpy/ndarrayobject.h PATHS ${PYTHON3_INCLUDE_DIRS} NO_DEFAULT_PATH)
if(NUMPY3_INCLUDE_NDARRAYOBJECT_DIR)
    set(NUMPY3_INCLUDE_DIR ${NUMPY3_INCLUDE_NDARRAYOBJECT_DIR})
else()
    execute_process(
        COMMAND ${PYTHON3_EXECUTABLE} -c
                "import numpy; import os; print(os.path.dirname(numpy.__file__) + '/core/include')"
        RESULT_VARIABLE FIND_NUMPY3_RESULT OUTPUT_VARIABLE NUMPY3_INCLUDE_DIR)
    string(STRIP "${NUMPY3_INCLUDE_DIR}" NUMPY3_INCLUDE_DIR)

    if(${FIND_NUMPY3_RESULT})
        message(FATAL_ERROR "Could not determine NumPy include directory")
    endif()
endif()

if(NOT EXISTS "${NUMPY3_INCLUDE_DIR}/numpy/ndarrayobject.h")
    message(FATAL_ERROR "Could not find numpy/ndarrayobject.h include file")
endif()

message(STATUS "NumPy Include Directory: ${NUMPY3_INCLUDE_DIR}")

include(${PYTHON2_SOURCE_DIR}/PythonPackageVersion.cmake)

include_directories(${PYTHON3_INCLUDE_DIRS} ${CMAKE_SOURCE_DIR}/SWIG ${PYTHON2_SOURCE_DIR} ${NUMPY3_INCLUDE_DIR})
get_filename_component(PYTHON3_LINK_DIRS "${PYTHON3_LIBRARIES}" DIRECTORY)
link_directories(${PYTHON3_LINK_DIRS})

if(NOT USE_PREGENERATED_SOURCE)
    include(FindSWIG)
    find_package(SWIG 4.0.2 REQUIRED)
    include(${CMAKE_SOURCE_DIR}/cmake/RRUseSwig.cmake)
    include(${PYTHON2_SOURCE_DIR}/PythonSwigVars.cmake)
    set(CMAKE_SWIG_OUTDIR ${CMAKE_CURRENT_BINARY_DIR})
    include_directories(${CMAKE_SOURCE_DIR}/RobotRaconteurCore/include)
    rr_swig_add_module(
        RobotRaconteurPython3
        python
        ${PYTHON2_SOURCE_DIR}/RobotRaconteurPython.i
        ${CMAKE_SOURCE_DIR}/SWIG/RobotRaconteurWrapped.cpp
        ${CMAKE_SOURCE_DIR}/SWIG/RobotRaconteurWrapped.h
        ${PYTHON2_SOURCE_DIR}/PythonTypeSupport.cpp
        ${PYTHON2_SOURCE_DIR}/PythonTypeSupport.h)
    swig_link_libraries(RobotRaconteurPython3 RobotRaconteurCore)
else()
    set(SWIG_MODULE_RobotRaconteurPython3_REAL_NAME _RobotRaconteurPython3)
    if("${SIZEOF_LONG_INT}" EQUAL 8 AND CMAKE_COMPILER_IS_GNUCXX)
        set(CMAKE_SWIG_OUTDIR ${PREGENERATED_SOURCE_DIR}/Python3/swigwordsize64/)
    else()
        set(CMAKE_SWIG_OUTDIR ${PREGENERATED_SOURCE_DIR}/Python3/swigwordsize32/)
    endif()
    include_directories(${CMAKE_SOURCE_DIR}/SWIG ${CMAKE_SWIG_OUTDIR})
    add_library(
        _RobotRaconteurPython3 MODULE
        ${CMAKE_SOURCE_DIR}/SWIG/RobotRaconteurWrapped.cpp ${CMAKE_SOURCE_DIR}/SWIG/RobotRaconteurWrapped.h
        ${PYTHON2_SOURCE_DIR}/PythonTypeSupport.cpp ${PYTHON2_SOURCE_DIR}/PythonTypeSupport.h
        ${CMAKE_SWIG_OUTDIR}/RobotRaconteurPythonPYTHON_wrap.cxx)
    target_link_libraries(_RobotRaconteurPython3 RobotRaconteurCore)
    set_target_properties(_RobotRaconteurPython3 PROPERTIES PREFIX "")
endif()

target_compile_definitions(
    ${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME} PRIVATE RR_PYTHON NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION
                                                           SWIG_TYPE_TABLE=robotraconteur_python)
target_include_directories(
    ${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME} PRIVATE ${PYTHON3_INCLUDE_DIRS} ${CMAKE_SOURCE_DIR}/SWIG
                                                           ${CMAKE_CURRENT_SOURCE_DIR} ${NUMPY3_INCLUDE_DIR})

if(MSVC)
    target_compile_options(${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME} PRIVATE "/bigobj")
endif()

rrsettargetdirs(${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME} "Python3/RobotRaconteur" "Python3/RobotRaconteur")

if(WIN32)
    set_target_properties(${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME} PROPERTIES SUFFIX ".pyd")
else()
    set_target_properties(${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME} PROPERTIES SUFFIX ".so")
endif()
set_target_properties(${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME} PROPERTIES OUTPUT_NAME "_RobotRaconteurPython")

if(NOT DEFINED RobotRaconteur_DIR)
    add_dependencies(${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME} RobotRaconteurCore)
endif()

add_custom_command(
    TARGET ${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME} POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SWIG_OUTDIR}/RobotRaconteurPython.py
            $<TARGET_FILE_DIR:${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME}>/)
add_custom_command(
    TARGET ${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME} POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/RobotRaconteurPythonError.py
            $<TARGET_FILE_DIR:${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME}>/)

file(GLOB RR_PY_SOURCES ${PYTHON2_SOURCE_DIR}/*.py)
foreach(P ${RR_PY_SOURCES})
    add_custom_command(
        TARGET ${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME} POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy ${P} $<TARGET_FILE_DIR:${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME}>/)
endforeach(P)

configure_file("${PYTHON2_SOURCE_DIR}/setup.py.in" "${CMAKE_BINARY_DIR}/out/Python3/setup.py" @ONLY)
configure_file("${PYTHON2_SOURCE_DIR}/setup.py.in" "${CMAKE_BINARY_DIR}/out_debug/Python3/setup.py" @ONLY)
configure_file("${PYTHON2_SOURCE_DIR}/setup.py.in" "${CMAKE_BINARY_DIR}/out_reldebug/Python3/setup.py" @ONLY)

include("${PYTHON2_SOURCE_DIR}/PythonExceptions.cmake")

set(BUILD_PYTHON3_WHEEL OFF CACHE BOOL "Enable building Python 3 wheels")
if(BUILD_PYTHON3_WHEEL)
    add_custom_target(
        RobotRaconteurPython3_Wheel ALL
        ${CMAKE_COMMAND}
        -E
        chdir
        "$<TARGET_FILE_DIR:${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME}>/.."
        "${PYTHON3_EXECUTABLE}"
        setup.py
        bdist_wheel
        DEPENDS ${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME})
    if(WIN32)
        set_target_properties(RobotRaconteurPython3_Wheel PROPERTIES EXCLUDE_FROM_DEFAULT_BUILD_DEBUG TRUE)
    endif()
endif()

# This mess is taken from github.com/ros/catkin/cmake/python.cmake...
set(enable_setuptools_deb_layout OFF)
if(ROBOTRACONTEUR_ROS)
    if(EXISTS "/etc/debian_version")
        set(enable_setuptools_deb_layout ON)
    endif()
endif()

option(SETUPTOOLS_DEB_LAYOUT "Enable debian style python package layout" ${enable_setuptools_deb_layout})
if(SETUPTOOLS_DEB_LAYOUT)
    message(STATUS "Using Debian Python package layout")
    set(SETUPTOOLS_ARG_EXTRA "--install-layout=deb")
endif()

option(INSTALL_PYTHON3 "Install Python3 library" OFF)
if(ROBOTRACONTEUR_ROS OR ROBOTRACONTEUR_COLCON OR INSTALL_PYTHON3)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/python3_install.cmake.in
                   ${CMAKE_CURRENT_BINARY_DIR}/python3_install.cmake @ONLY)
    install(SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/python3_install.cmake)
endif()

if(ROBOTRACONTEUR_ROS OR ROBOTRACONTEUR_COLCON)
    # Allows Colcon to find Python package
    if(SETUPTOOLS_DEB_LAYOUT)
        set(ROS_PYTHONPATH lib/python3/dist-packages)
    elseif(WIN32)
        set(ROS_PYTHONPATH lib/site-packages)
    else()
        set(ROS_PYTHONPATH lib/python3.${PYTHON_VERSION_MINOR}/dist-packages)
    endif()
    file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/share/robotraconteur/hook/python_path.dsv
         "prepend-non-duplicate;PYTHONPATH;${ROS_PYTHONPATH}")
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/robotraconteur/hook/python_path.dsv
            DESTINATION share/robotraconteur/hook)
endif()

if(BUILD_DOCUMENTATION)

    find_program(SPHINX_EXECUTABLE NAMES sphinx-build)

    if(NOT SPHINX_EXECUTABLE)
        message(FATAL_ERROR "Sphinx is required to build Python documentation")
    endif()

    configure_file("${CMAKE_SOURCE_DIR}/docs/python/conf.py.in" "${CMAKE_BINARY_DIR}/out/Python3/sphinx/conf.py" @ONLY)
    configure_file("${CMAKE_SOURCE_DIR}/docs/python/conf.py.in" "${CMAKE_BINARY_DIR}/out_debug/Python3/sphinx/conf.py"
                   @ONLY)
    configure_file("${CMAKE_SOURCE_DIR}/docs/python/conf.py.in"
                   "${CMAKE_BINARY_DIR}/out_reldebug/Python3/sphinx/conf.py" @ONLY)

    file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/docs/python3)

    add_custom_target(
        RobotRaconteurPython3_doc
        COMMAND ${SPHINX_EXECUTABLE} -c $<TARGET_FILE_DIR:${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME}>/../sphinx
                ${CMAKE_SOURCE_DIR}/docs/python/source ${CMAKE_BINARY_DIR}/docs/python3
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating Python documentation with Sphinx"
        VERBATIM
        DEPENDS ${SWIG_MODULE_RobotRaconteurPython3_REAL_NAME})
endif()

=== test/java/CMakeLists.txt ===
if(NOT ANDROID)

    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/test)

    if(NOT RobotRaconteur_GEN)
        set(RobotRaconteur_GEN RobotRaconteurGen)
    endif()

    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/test_src")

    robotraconteur_generate_thunk(
        RR_THUNK_SRCS
        com.robotraconteur.testing.TestService1.robdef
        com.robotraconteur.testing.TestService2.robdef
        com.robotraconteur.testing.TestService3.robdef
        com.robotraconteur.testing.TestService4.robdef
        LANG
        java
        INCLUDE_DIRS
        "${CMAKE_SOURCE_DIR}/test/robdef"
        OUTDIR
        "${CMAKE_CURRENT_BINARY_DIR}/test_src")

    add_custom_target(RobotRaconteurJavaTest_gen DEPENDS ${RR_THUNK_SRCS})

    add_custom_target(
        RobotRaconteurJavaTest ALL
        "${Java_JAVAC_EXECUTABLE}"
        -encoding
        UTF8
        -target
        7
        -source
        7
        -Xlint:none
        com/robotraconteur/javatest/*.java
        ${CMAKE_CURRENT_BINARY_DIR}/test_src/com/robotraconteur/testing/TestService1/*.java
        ${CMAKE_CURRENT_BINARY_DIR}/test_src/com/robotraconteur/testing/TestService2/*.java
        ${CMAKE_CURRENT_BINARY_DIR}/test_src/com/robotraconteur/testing/TestService3/*.java
        -d
        "${CMAKE_CURRENT_BINARY_DIR}/test"
        -classpath
        "${CMAKE_BINARY_DIR}/RobotRaconteurJava/bin"
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/test")
    add_dependencies(RobotRaconteurJavaTest RobotRaconteurJava RobotRaconteurJavaTest_gen)

    add_custom_command(
        TARGET RobotRaconteurJavaTest
        POST_BUILD
        COMMAND
            ${CMAKE_COMMAND} -E make_directory
            "${CMAKE_BINARY_DIR}/test/$<$<CONFIG:debug>:out_debug>$<$<CONFIG:release>:out>$<$<CONFIG:relwithdebinfo>:out_reldebug>/Java"
        COMMAND
            "${Java_JAR_EXECUTABLE}" cf
            "${CMAKE_BINARY_DIR}/test/$<$<CONFIG:debug>:out_debug>$<$<CONFIG:release>:out>$<$<CONFIG:relwithdebinfo>:out_reldebug>/Java/RobotRaconteurJavaTest.jar"
            *
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/test")

    add_dependencies(RobotRaconteurJavaTest RobotRaconteurJava)

    set(RR_JAVA_TEST_CMD "${Java_JAVA_EXECUTABLE}")
    if(WIN32)
        set(RR_JAVA_TEST_CMD_ARG
            "-cp ${CMAKE_BINARY_DIR}/@OUT_DIR_NAME@/Java/RobotRaconteur.jar\\\;${CMAKE_BINARY_DIR}/test/@OUT_DIR_NAME@/Java/RobotRaconteurJavaTest.jar -Djava.library.path=${CMAKE_BINARY_DIR}/@OUT_DIR_NAME@/Java/ -XX:MaxJavaStackTraceDepth=100000 com.robotraconteur.javatest.RobotRaconteurJavaTest"
        )
    else()
        set(RR_JAVA_TEST_CMD_ARG
            "-cp ${CMAKE_BINARY_DIR}/@OUT_DIR_NAME@/Java/RobotRaconteur.jar:${CMAKE_BINARY_DIR}/test/@OUT_DIR_NAME@/Java/RobotRaconteurJavaTest.jar -Djava.library.path=${CMAKE_BINARY_DIR}/@OUT_DIR_NAME@/Java/ -XX:MaxJavaStackTraceDepth=100000 com.robotraconteur.javatest.RobotRaconteurJavaTest"
        )
    endif()
    rrconfiguretest(
        test_prog_java
        "${RR_JAVA_TEST_CMD}"
        "test_prog"
        NOCTEST
        NODEBUG
        ARGS
        "${RR_JAVA_TEST_CMD_ARG}")
    rrconfiguretest(test_java_loopback "${RR_JAVA_TEST_CMD}" "test_prog" ARGS "${RR_JAVA_TEST_CMD_ARG} loopback")
    rrconfiguretest(test_java_loopback2 "${RR_JAVA_TEST_CMD}" "test_prog" ARGS "${RR_JAVA_TEST_CMD_ARG} loopback2")

endif()

=== test/lfsr/CMakeLists.txt ===
add_library(robotraconteur_test_lfsr SHARED src/robotraconteur_test_lfsr.c)
target_include_directories(robotraconteur_test_lfsr PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/include)

if(WIN32)
    target_compile_definitions(robotraconteur_test_lfsr PRIVATE ROBOTRACONTEUR_TEST_LFSR_EXPORTS
                               INTERFACE ROBOTRACONTEUR_TEST_LFSR_IMPORTS)
endif()

rr_set_test_target_dirs(robotraconteur_test_lfsr bin lib)

add_executable(robotraconteur_test_lfsr_print src/robotraconteur_test_lfsr_print.cpp)
target_link_libraries(robotraconteur_test_lfsr_print robotraconteur_test_lfsr RobotRaconteurCore)

rr_set_test_target_dirs(robotraconteur_test_lfsr_print bin lib)

=== test/matlab/CMakeLists.txt ===
find_package(Matlab COMPONENTS MAIN_PROGRAM)

set(RR_MATLAB_TEST_CMD "\"${CMAKE_COMMAND}\"")
if(WIN32)
    set(RR_TEST_SERVER_LIB "${CMAKE_BINARY_DIR}/test/@OUT_DIR_NAME@/bin/robotraconteur_test_server_lib.dll")
else()
    set(RR_TEST_SERVER_LIB "${CMAKE_BINARY_DIR}/test/@OUT_DIR_NAME@/lib/robotraconteur_test_server_lib.so")
endif()
set(RR_MATLABPATH "${CMAKE_BINARY_DIR}/@OUT_DIR_NAME@/Matlab")
set(RR_MATLAB_TEST_CMD_ARGS
    "-E env ROBOTRACONTEUR_TEST_SERVER_LIB=\"${RR_TEST_SERVER_LIB}\" ROBOTRACONTEUR_TEST_SERVER_LIB_HFILE=\"${CMAKE_SOURCE_DIR}/test/cpp/service/test_server_lib.h\" ROBOTRACONTEUR_ROBDEF_PATH=\"${CMAKE_SOURCE_DIR}/test/robdef\" MATLABPATH=\"${RR_MATLABPATH}\" \"${Matlab_MAIN_PROGRAM}\" ${RR_MATLAB_TEST_EXTRA_ARGS} -batch \"cd(fullfile('${CMAKE_CURRENT_SOURCE_DIR}'))\\\; RobotRaconteurMatlabTestLoopback\" "
)

rrconfiguretest(test_matlab_loopback "${RR_MATLAB_TEST_CMD}" "test_prog" ARGS "${RR_MATLAB_TEST_CMD_ARGS}")

=== test/net/CMakeLists.txt ===
if(NOT RR_NET_BUILD_NATIVE_ONLY)

    include(${CMAKE_SOURCE_DIR}/RobotRaconteurGen/cmake/RobotRaconteurGenerateThunk.cmake)

    if(NOT RobotRaconteur_GEN)
        set(RobotRaconteur_GEN RobotRaconteurGen)
    endif()

    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/test")

    robotraconteur_generate_thunk(
        RR_THUNK_SRCS
        com.robotraconteur.testing.TestService1.robdef
        com.robotraconteur.testing.TestService2.robdef
        com.robotraconteur.testing.TestService3.robdef
        com.robotraconteur.testing.TestService4.robdef
        com.robotraconteur.testing.TestService5.robdef
        LANG
        csharp
        INCLUDE_DIRS
        "${CMAKE_SOURCE_DIR}/test/robdef"
        OUTDIR
        "${CMAKE_CURRENT_BINARY_DIR}/test")

    add_custom_target(RobotRaconteurNETTest_gen DEPENDS ${RR_THUNK_SRCS})
    # add_dependencies(RobotRaconteurNETNative RobotRaconteurNETTest_gen)

    if(WIN32)
        add_custom_target(
            RobotRaconteurNETTest ALL
            msbuild $<$<CONFIG:debug>:/p:Configuration=Debug>$<$<CONFIG:release>:/p:Configuration=Release> /t:rebuild
            RobotRaconteurNETTest.csproj WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
    else()
        find_program(XBUILD_EXECUTABLE NAMES xbuild msbuild)
        add_custom_target(
            RobotRaconteurNETTest ALL
            "${XBUILD_EXECUTABLE}"
            $<$<CONFIG:debug>:/p:Configuration=Debug>$<$<CONFIG:release>:/p:Configuration=Release>
            RobotRaconteurNETTest.csproj
            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
    endif()
    add_dependencies(RobotRaconteurNETTest RobotRaconteurNET RobotRaconteurNETTest_gen)

    if(WIN32)
        if(CMAKE_SIZEOF_VOID_P EQUAL 8)
            set(RR_PREFER_32BIT "<Prefer32Bit>false</Prefer32Bit>")
        else()
            set(RR_PREFER_32BIT "<Prefer32Bit>true</Prefer32Bit>")
        endif()
    endif()

    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/RobotRaconteurNETTest/RobotRaconteurNETTest.csproj.in"
                   "${CMAKE_CURRENT_BINARY_DIR}/RobotRaconteurNETTest.csproj" @ONLY)

    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/netstandard/RobotRaconteurNETTest.csproj.in"
                   "${CMAKE_CURRENT_BINARY_DIR}/netstandard/Test/RobotRaconteurNETTest.csproj" @ONLY)

    if(WIN32)
        set(RR_NET_TEST_CMD "\"${CMAKE_COMMAND}\"")
        set(RR_NET_TEST_CMD_ARGS
            "-E env PATH=\"%PATH%\\\;${CMAKE_BINARY_DIR}/@OUT_DIR_NAME@/NET/Native\" ${CMAKE_BINARY_DIR}/test/@OUT_DIR_NAME@/NET/RobotRaconteurNETTest"
        )
    else()
        find_program(MONO_EXECUTABLE mono)
        set(RR_NET_TEST_CMD "\"${CMAKE_COMMAND}\"")
        set(RR_NET_TEST_CMD_ARGS
            "-E env LD_LIBRARY_PATH=$LD_LIBRARY_PATH:${CMAKE_BINARY_DIR}/@OUT_DIR_NAME@/NET/Native\ ${MONO_EXECUTABLE} ${CMAKE_BINARY_DIR}/test/@OUT_DIR_NAME@/NET/RobotRaconteurNETTest.exe"
        )
    endif()
    rrconfiguretest(test_prog_net "${RR_NET_TEST_CMD}" "test_prog" NOCTEST ARGS "${RR_NET_TEST_CMD_ARGS}")
    rrconfiguretest(test_net_loopback "${RR_NET_TEST_CMD}" "test_prog" ARGS "${RR_NET_TEST_CMD_ARGS} loopback")
    rrconfiguretest(test_net_loopback2 "${RR_NET_TEST_CMD}" "test_prog" ARGS "${RR_NET_TEST_CMD_ARGS} loopback2")
    rrconfiguretest(test_net_loopback3 "${RR_NET_TEST_CMD}" "test_prog" ARGS "${RR_NET_TEST_CMD_ARGS} loopback3")

    if(WIN32 AND (MSVC_VERSION GREATER 1900))
        add_custom_target(
            RobotRaconteurNETTest_standard ALL
            msbuild /verbosity:quiet /restore
            $<$<CONFIG:debug>:/p:Configuration=Debug>$<$<CONFIG:release>:/p:Configuration=Release> /t:rebuild
            RobotRaconteurNETTest.csproj
            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/netstandard/Test")
        add_dependencies(RobotRaconteurNETTest_standard RobotRaconteurNET_standard RobotRaconteurNETTest_gen)

        set(RR_NET_STD_TEST_CMD "\"${CMAKE_COMMAND}\"")
        set(RR_NET_STD_TEST_CMD_ARGS
            "-E env PATH=\"%PATH%\\\;${CMAKE_BINARY_DIR}/@OUT_DIR_NAME@/NET/Native\" dotnet ${CMAKE_BINARY_DIR}/test/@OUT_DIR_NAME@/NET/RobotRaconteurNETTest"
        )
    endif()

endif()

=== test/python/CMakeLists.txt ===
if(BUILD_PYTHON3)
    if(WIN32)
        set(RR_TEST_PYTHON_PATH "${CMAKE_BINARY_DIR}/@OUT_DIR_NAME@/Python3\\\;${CMAKE_CURRENT_SOURCE_DIR}")
    else()
        set(RR_TEST_PYTHON_PATH "${CMAKE_BINARY_DIR}/@OUT_DIR_NAME@/Python3:${CMAKE_CURRENT_SOURCE_DIR}")
    endif()

    set(RR_PYTHON_TEST_CMD "\"${CMAKE_COMMAND}\"")
    set(RR_PYTHON_TEST_CMD_ARGS
        "-E env PYTHONPATH=${RR_TEST_PYTHON_PATH} ROBOTRACONTEUR_ROBDEF_PATH=${CMAKE_SOURCE_DIR}/test/robdef \"${PYTHON3_EXECUTABLE}\" "
    )

    rrconfiguretest(
        test_python3_module
        "${RR_PYTHON_TEST_CMD}"
        "test_prog"
        NOCTEST
        NODEBUG
        ARGS
        "${RR_PYTHON_TEST_CMD_ARGS} -m")
    rrconfiguretest(test_python3_pytest "${RR_PYTHON_TEST_CMD}" "test_prog" NODEBUG ARGS
                    "${RR_PYTHON_TEST_CMD_ARGS} -m pytest ${CMAKE_SOURCE_DIR}")

endif()

if(BUILD_PYTHON)
    if(WIN32)
        set(RR_TEST_PYTHON_PATH "${CMAKE_BINARY_DIR}/@OUT_DIR_NAME@/Python\\\;${CMAKE_CURRENT_SOURCE_DIR}")
    else()
        set(RR_TEST_PYTHON_PATH "${CMAKE_BINARY_DIR}/@OUT_DIR_NAME@/Python:${CMAKE_CURRENT_SOURCE_DIR}")
    endif()

    set(RR_PYTHON_TEST_CMD "\"${CMAKE_COMMAND}\"")
    set(RR_PYTHON_TEST_CMD_ARGS
        "-E env PYTHONPATH=${RR_TEST_PYTHON_PATH} ROBOTRACONTEUR_ROBDEF_PATH=${CMAKE_SOURCE_DIR}/test/robdef \"${PYTHON_EXECUTABLE}\" "
    )

    rrconfiguretest(
        test_python_module
        "${RR_PYTHON_TEST_CMD}"
        "test_prog"
        NOCTEST
        NODEBUG
        ARGS
        "${RR_PYTHON_TEST_CMD_ARGS} -m")
    rrconfiguretest(test_python_pytest "${RR_PYTHON_TEST_CMD}" "test_prog" NODEBUG ARGS
                    "${RR_PYTHON_TEST_CMD_ARGS} -m pytest ${CMAKE_SOURCE_DIR}")

endif()

=== debian/changelog ===
ros-noetic-robotraconteur (0.16.0-2buster) buster; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- John Wason <wason@wasontech.com>  Sun, 05 Feb 2023 23:11:59 -0000

=== debian/control ===
Source: ros-noetic-robotraconteur
Section: misc
Priority: optional
Maintainer: John Wason <wason@wasontech.com>
Build-Depends: debhelper (>= 9.0.0), libbluetooth-dev, libboost-all-dev, libdbus-1-dev, libssl-dev, libusb-1.0-0-dev, openssl, python3-dev, python3-numpy, ros-noetic-catkin, zlib1g-dev
Homepage: http://robotraconteur.com
Standards-Version: 3.9.2

Package: ros-noetic-robotraconteur
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libbluetooth-dev, libboost-all-dev, libdbus-1-dev, libssl-dev, libusb-1.0-0-dev, openssl, python3-dev, python3-numpy, zlib1g-dev
Description: Robot Raconteur ROS Package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-robotraconteur//opt/ros/noetic/lib/:$(CURDIR)/debian/ros-noetic-robotraconteur//opt/ros/noetic/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
